-------------------------------------------------------------------------------------
--  File Name   : clock_monitor_sync.vhd
--  Function    : ^NbNĎ{H
--  Author      : F.O (ProXi)
-- ylz     : {\[X ASIANL@ (Attributed SIgnAl Naming)  ŋLqĂB
--              :   ڍׂ http://www.proxi.co.jp/technolo/asian.htm Q
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
--  ^NbNĎ{H
-------------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

entity clock_monitor_sync is
    generic (DCNT_BIT       : integer := 1;                 -- ĎNbNJE^rbg
             DCNT_ENB       : integer := 0;                 -- ĎNbNJE^ ENABLE/DISABLE  0:DISABLE 1:ENABLE
             TCNT_BIT       : integer := 4;                 -- ԃJE^rbg
             TIME_UP_VAL    : integer := 15);               -- G[oԐݒliVXeNbNZj 
    port (
      -- in
        a_rst               : in  std_logic;                                -- 񓯊Zbg
        clk                 : in  std_logic;                                -- VXeNbN
        a_monitored_clk     : in  std_logic;                                -- 񓯊ĎNbN
        sp_error_clear      : in  std_logic;                                -- G[NAipX́j
      -- out
        s_clk_down_status   : out std_logic;                                -- NbN~G[ԏói񃉃b`AA)
        sh_clk_down         : out std_logic;                                -- NbN~G[b`o
        cp_tcnt_clear       : out std_logic;                                -- eXgpԃJE^NAo
        sv_tcnt             : out std_logic_vector(TCNT_BIT-1 downto 0)     -- eXgpԃJE^o
    );
end;

architecture rtl of clock_monitor_sync is
    signal xa_monitored_clk     : std_logic;
    signal xm_monitored_clk     : std_logic;
    signal xs_monitored_clk_q0  : std_logic;
    signal xs_monitored_clk_q1  : std_logic;
    signal xcp_tcnt_clear       : std_logic;
    signal xc_clk_down_status   : std_logic;
    signal xs_clk_down_status_q : std_logic;
    signal xsh_clk_down         : std_logic;
    signal xcp_clk_down_on      : std_logic;
    signal xs1v_dcnt            : std_logic_vector(DCNT_BIT-1 downto 0);
    signal xsv_tcnt             : std_logic_vector(TCNT_BIT-1 downto 0);
    
begin
 
    -- divide_counter ij
    process (a_rst, a_monitored_clk) begin
        if (a_rst = '1') then
            xs1v_dcnt     <= (others => '0');
        elsif (a_monitored_clk'event and a_monitored_clk = '1') then
            xs1v_dcnt <= xs1v_dcnt +1;
        end if;
    end process;

    xa_monitored_clk <= a_monitored_clk when (DCNT_ENB = 0) else xs1v_dcnt(DCNT_BIT-1);     -- ĎMI

   -- synchronizer
    process (a_rst, clk) begin
        if (a_rst = '1') then
            xm_monitored_clk        <= '0';
            xs_monitored_clk_q0     <= '0';
            xs_monitored_clk_q1     <= '0';
        elsif (clk'event and clk='1') then
            xm_monitored_clk        <= xa_monitored_clk;
            xs_monitored_clk_q0     <= xm_monitored_clk;
            xs_monitored_clk_q1     <= xs_monitored_clk_q0;
        end if;
    end process;

    xcp_tcnt_clear <= xs_monitored_clk_q0 and (not xs_monitored_clk_q1);  -- ĎM̗オ茟o

    -- time_counter iԃJE^j
    process (a_rst, clk) begin
        if (a_rst = '1') then
            xsv_tcnt <= (others => '0');
        elsif (clk'event and clk='1') then
            if (xcp_tcnt_clear = '1') then          -- ĎM̗オŃJE^NA
                xsv_tcnt <= (others => '0');
            elsif (sp_error_clear = '1') then       -- G[NAM͂ŃJE^NA
                xsv_tcnt <= (others => '0');
            elsif (xc_clk_down_status = '0') then   -- ԃJE^^CAbvȂ clk ŃCNg
                xsv_tcnt <= xsv_tcnt +1;
            end if;
        end if;
    end process;

    -- comparator (check clock down status)
    xc_clk_down_status <= '1' when ( xsv_tcnt >= conv_std_logic_vector(TIME_UP_VAL, TCNT_BIT) ) else '0';

    -- dff
    process (a_rst, clk) begin
        if (a_rst = '1') then
            xs_clk_down_status_q <= '0';
        elsif (clk'event and clk='1') then
            xs_clk_down_status_q <= xc_clk_down_status;
        end if;
    end process;

    xcp_clk_down_on <= xc_clk_down_status and (not xs_clk_down_status_q);   -- NbN_E~オ茟o

    --  s-r ff
    process (a_rst, clk) begin
        if (a_rst = '1') then
            xsh_clk_down    <= '0';
        elsif (clk'event and clk='1') then
            if (xcp_clk_down_on = '1') then
                xsh_clk_down    <= '1';             -- NbN_EG[z[h
            elsif (sp_error_clear = '1') then
                xsh_clk_down    <= '0';             -- NbN_EG[NA
            end if;
        end if;
    end process;

    -- set output
    s_clk_down_status   <= xs_clk_down_status_q;
    sh_clk_down         <= xsh_clk_down;
    cp_tcnt_clear       <= xcp_tcnt_clear;           -- fot test
    sv_tcnt             <= xsv_tcnt;                 -- fot test

end rtl;

