-------------------------------------------------------------------------------------
--  File Name   : clock_monitor_sync_sample.vhd
--  Function    : ^NbNĎ{H̉p
--  Author      : F.O (ProXi)
-- yl1z    : {\[X ASIANL@ (Attributed SIgnAl Naming)  ŋLqĂB
--              :   ڍׂ http://www.proxi.co.jp/technolo/asian.htm Q
--
-- yl2z    : {\[Xł͒Pׂ̈ clock_monitor_sync R|[lg outM
--              : 𒼐 out[qɐڑĂ
-------------------------------------------------------------------------------------

-------------------------------------------------------------------------------------
--  NbNĎTv
--    VXeNbN clk  a_monitored_clk1, a_monitored_clk2̒~ĎB
--
--   NbNdl
--      VXeNbN    clk              : 20MHz, 50nSec
--      ĎNbN1     a_monitored_clk1 : 50MHz, 20nSec  86.25MHz, 160nSec/clock Ď
--                                             ~Ď 50nSec/clock x 20 clock = 1 usec 
--      ĎNbN2     a_monitored_clk2 : 8MHz, 125nSec/clock  ŕclk2𒼐ڊĎ
--                                             ~Ď 50nSec/clock x 25 clock = 1.25 usec 
-------------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

entity clock_monitor_sync_sample is
    port (
      -- in
        a_rst               : in  std_logic;                        -- VXeZbgi񓯊j
        clk                 : in  std_logic;                        -- 20MHz, 50nSec
        ----
        a_monitored_clk1    : in  std_logic;                        -- 50MHz, 20nSec  8 6.25MHz, 160nSec Ď
        sp_error_clear1     : in  std_logic;                        -- a_monitored_clk1 G[NAipX́j
        ----
        a_monitored_clk2    : in  std_logic;                        -- 8MHz, 125nSec 
        sp_error_clear2     : in  std_logic;                        -- a_monitored_clk2 G[NAipX́j
      -- out
        s_clk_down_status1  : out std_logic;                        -- NbN~G[ԏo1i񃉃b`AA)
        sh_clk_down1        : out std_logic;                        -- NbN~G[b`o1
        cp_tcnt_clear1      : out std_logic;                        -- eXgpԃJE^NAo1
        sv_tcnt1            : out std_logic_vector(4 downto 0);     -- eXgpԃJE^o1
        ----
        s_clk_down_status2  : out std_logic;                        -- NbN~G[ԏo2i񃉃b`AA)
        sh_clk_down2        : out std_logic;                        -- NbN~G[b`o2
        cp_tcnt_clear2      : out std_logic;                        -- eXgpԃJE^NAo2
        sv_tcnt2            : out std_logic_vector(4 downto 0)      -- eXgpԃJE^o2
    );
end;

architecture rtl of clock_monitor_sync_sample is

begin
    -- NbN1 Ď
    clock_monitor_sync1 : entity work.clock_monitor_sync
        generic map (
            DCNT_BIT    => 3,                   -- ĎNbNJE^rbg : 8
            DCNT_ENB    => 1,                   -- ĎNbNJE^ ENABLE/DISABLE  0:DISABLE 1:ENABLE
            TCNT_BIT    => 5,                   -- ԃJE^rbg
            TIME_UP_VAL => 20                   -- G[oԐݒliVXeNbNZj: 50nSec/clock x 20 clock = 1 usec
        )

        port map (
          -- in
            a_rst               => a_rst,                   -- 񓯊Zbg
            clk                 => clk,                     -- VXeNbN
            a_monitored_clk     => a_monitored_clk1,        -- 񓯊ĎNbN
            sp_error_clear      => sp_error_clear1,         -- G[NAipX́j
          -- out
            s_clk_down_status   => s_clk_down_status1,      -- NbN~G[ԏói񃉃b`AA)
            sh_clk_down         => sh_clk_down1,            -- NbN~G[b`o
            cp_tcnt_clear       => cp_tcnt_clear1,          -- eXgpԃJE^NAo
            sv_tcnt             => sv_tcnt1                 -- eXgpԃJE^o
        );


    -- NbN2 Ď
    clock_monitor_sync2 : entity work.clock_monitor_sync
        generic map (
            DCNT_BIT    => 1,                   -- ĎNbNJE^rbg : sgp
            DCNT_ENB    => 0,                   -- ĎNbNJE^ ENABLE/DISABLE  0:DISABLE 1:ENABLE
            TCNT_BIT    => 5,                   -- ԃJE^rbg
            TIME_UP_VAL => 25                   -- G[oԐݒliVXeNbNZj: 50nSec/clock x 25 clock = 1.25 usec
        )

        port map (
          -- in
            a_rst               => a_rst,                   -- 񓯊Zbg
            clk                 => clk,                     -- VXeNbN
            a_monitored_clk     => a_monitored_clk2,        -- 񓯊ĎNbN
            sp_error_clear      => sp_error_clear2,         -- G[NAipX́j
          -- out
            s_clk_down_status   => s_clk_down_status2,      -- NbN~G[ԏói񃉃b`AA)
            sh_clk_down         => sh_clk_down2,            -- NbN~G[b`o
            cp_tcnt_clear       => cp_tcnt_clear2,          -- eXgpԃJE^NAo
            sv_tcnt             => sv_tcnt2                 -- eXgpԃJE^o
        );

end rtl;

