-------------------------------------------------------------------------------------
--  File Name   : clock_monitor_sync_sample.vht
--  Function    : ^NbNĎ{H̉p eXgx`
--  Author      : F.O (ProXi)
-- ylz     : {\[X Quartus II (Altera)   test bench template Writer 
--                t@CҏŴłB
-------------------------------------------------------------------------------------
LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

ENTITY clock_monitor_sync_sample_vhd_tst IS
END clock_monitor_sync_sample_vhd_tst;
ARCHITECTURE clock_monitor_sync_sample_arch OF clock_monitor_sync_sample_vhd_tst IS
-- constants                                                 
   constant clk_period                  : time := 50 ns;        -- 20 MHz
   constant a_monitored_clk1_period     : time := 20 ns;        -- 50 MHz
   constant a_monitored_clk2_period     : time := 125 ns;       -- 8 MHz

-- signals                                                   
signal usec_time_cnt    : integer range 0 to 250 := 0;   -- uSec time_counter

SIGNAL a_monitored_clk1 : STD_LOGIC;
SIGNAL a_monitored_clk2 : STD_LOGIC;
SIGNAL a_rst : STD_LOGIC;
SIGNAL clk : STD_LOGIC;
SIGNAL cp_tcnt_clear1 : STD_LOGIC;
SIGNAL cp_tcnt_clear2 : STD_LOGIC;
SIGNAL s_clk_down_status1 : STD_LOGIC;
SIGNAL s_clk_down_status2 : STD_LOGIC;
SIGNAL sh_clk_down1 : STD_LOGIC;
SIGNAL sh_clk_down2 : STD_LOGIC;
SIGNAL sp_error_clear1 : STD_LOGIC;
SIGNAL sp_error_clear2 : STD_LOGIC;
SIGNAL sv_tcnt1 : STD_LOGIC_VECTOR(4 DOWNTO 0);
SIGNAL sv_tcnt2 : STD_LOGIC_VECTOR(4 DOWNTO 0);
COMPONENT clock_monitor_sync_sample
	PORT (
	a_monitored_clk1 : IN STD_LOGIC;
	a_monitored_clk2 : IN STD_LOGIC;
	a_rst : IN STD_LOGIC;
	clk : IN STD_LOGIC;
	cp_tcnt_clear1 : OUT STD_LOGIC;
	cp_tcnt_clear2 : OUT STD_LOGIC;
	s_clk_down_status1 : OUT STD_LOGIC;
	s_clk_down_status2 : OUT STD_LOGIC;
	sh_clk_down1 : OUT STD_LOGIC;
	sh_clk_down2 : OUT STD_LOGIC;
	sp_error_clear1 : IN STD_LOGIC;
	sp_error_clear2 : IN STD_LOGIC;
	sv_tcnt1 : OUT STD_LOGIC_VECTOR(4 DOWNTO 0);
	sv_tcnt2 : OUT STD_LOGIC_VECTOR(4 DOWNTO 0)
	);
END COMPONENT;

BEGIN
	i1 : clock_monitor_sync_sample
	PORT MAP (
-- list connections between master ports and signals
	a_monitored_clk1 => a_monitored_clk1,
	a_monitored_clk2 => a_monitored_clk2,
	a_rst => a_rst,
	clk => clk,
	cp_tcnt_clear1 => cp_tcnt_clear1,
	cp_tcnt_clear2 => cp_tcnt_clear2,
	s_clk_down_status1 => s_clk_down_status1,
	s_clk_down_status2 => s_clk_down_status2,
	sh_clk_down1 => sh_clk_down1,
	sh_clk_down2 => sh_clk_down2,
	sp_error_clear1 => sp_error_clear1,
	sp_error_clear2 => sp_error_clear2,
	sv_tcnt1 => sv_tcnt1,
	sv_tcnt2 => sv_tcnt2
	);


    ---------------------------------------
    -- system reset
    a_rst  <= '1', '0' after 10 ns;          -- VXeZbg

    -- uSec ^CJE^
    time_count_process : process begin
        while (usec_time_cnt < 300) loop
            wait for 1 us;
            usec_time_cnt <= usec_time_cnt + 1;
        end loop;
        wait;
    end process;


    -- clk 
    clk_generate_proces : process begin
            clk <= '0';                    -- clk 
            wait for clk_period /2;
            clk <= '1';
            wait for clk_period /2;
    end process;

    -- a_monitored_clk1 
    a_monitored_clk1_generate_proces : process begin
        sp_error_clear1  <= '0';

        while (usec_time_cnt < 5) loop
            a_monitored_clk1 <= '1';                    -- a_monitored_clk1 
            wait for a_monitored_clk1_period /2;
            a_monitored_clk1 <= '0';
            wait for a_monitored_clk1_period /2;
        end loop;

        a_monitored_clk1 <= '0';                        -- a_monitored_clk1 _EiL̂܂܁j
        wait for 2 us;

        while (usec_time_cnt < 8) loop
            a_monitored_clk1 <= '1';                    -- a_monitored_clk1 
            wait for a_monitored_clk1_period /2;
            a_monitored_clk1 <= '0';
            wait for a_monitored_clk1_period /2;
        end loop;

        sp_error_clear1  <= '1', '0' after clk_period;   -- G[Zbg

        --------------------

        while (usec_time_cnt < 15) loop
            a_monitored_clk1 <= '1';                    -- a_monitored_clk1 
            wait for a_monitored_clk1_period /2;
            a_monitored_clk1 <= '0';
            wait for a_monitored_clk1_period /2;
        end loop;

        a_monitored_clk1 <= '1';                        -- a_monitored_clk1 _EiĤ܂܁j
        wait for 2 us;

        while (usec_time_cnt < 20) loop
            a_monitored_clk1 <= '1';                    -- a_monitored_clk1 
            wait for a_monitored_clk1_period /2;
            a_monitored_clk1 <= '0';
            wait for a_monitored_clk1_period /2;
        end loop;

        sp_error_clear1  <= '1', '0' after clk_period;   -- G[Zbg

        while (usec_time_cnt < 50) loop
            a_monitored_clk1 <= '1';                    -- a_monitored_clk1 
            wait for a_monitored_clk1_period /2;
            a_monitored_clk1 <= '0';
            wait for a_monitored_clk1_period /2;
        end loop;

        wait;
    end process;


    -- a_monitored_clk2 
    a_monitored_clk2_generate_proces : process begin
        sp_error_clear2  <= '0';

        while (usec_time_cnt < 7) loop
            a_monitored_clk2 <= '1';                    -- a_monitored_clk2 
            wait for a_monitored_clk2_period /2;
            a_monitored_clk2 <= '0';
            wait for a_monitored_clk2_period /2;
        end loop;

        a_monitored_clk2 <= '0';                        -- a_monitored_clk2 _EiL̂܂܁j
        wait for 2 us;

        while (usec_time_cnt < 12) loop
            a_monitored_clk2 <= '1';                    -- a_monitored_clk2 
            wait for a_monitored_clk2_period /2;
            a_monitored_clk2 <= '0';
            wait for a_monitored_clk2_period /2;
        end loop;


        sp_error_clear2  <= '1', '0' after clk_period;   -- G[Zbg

        --------------------

        while (usec_time_cnt < 14) loop
            a_monitored_clk2 <= '1';                    -- a_monitored_clk2 
            wait for a_monitored_clk2_period /2;
            a_monitored_clk2 <= '0';
            wait for a_monitored_clk2_period /2;
        end loop;

        a_monitored_clk2 <= '1';                        -- a_monitored_clk2 _EiĤ܂܁j
        wait for 2 us;

        while (usec_time_cnt < 22) loop
            a_monitored_clk2 <= '1';                    -- a_monitored_clk2 
            wait for a_monitored_clk2_period /2;
            a_monitored_clk2 <= '0';
            wait for a_monitored_clk2_period /2;
        end loop;

        sp_error_clear2  <= '1', '0' after clk_period;   -- G[Zbg

        while (usec_time_cnt < 100) loop
            a_monitored_clk2 <= '1';                    -- a_monitored_clk2 
            wait for a_monitored_clk2_period /2;
            a_monitored_clk2 <= '0';
            wait for a_monitored_clk2_period /2;
        end loop;

        wait;
    end process;


END clock_monitor_sync_sample_arch;
